<template>
  <a-spin :spinning="confirmLoading">
    <j-form-container :disabled="formDisabled">
      <a-form-model ref="form" :model="model" :rules="validatorRules" slot="detail">
        <a-row>
          <a-col :span="24">
            <a-form-model-item label="关联支付方式" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="payTypeId">
<!--              <a-input v-model="model.payTypeId" placeholder="请输入关联支付方式"  ></a-input>-->
              <a-select
                      v-model="model.payTypeId"
                      placeholder="请选择支付方式"
                      :allowClear="true"
                      disabled
              >
                <a-select-option :value="item.id" v-for="(item,index) in payTypeList" :key="index">{{ item.name }}</a-select-option>
              </a-select>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="商户号" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="merchantNo">
              <a-input v-model="model.merchantNo" placeholder="请输入商户号"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="终端号" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="terminalNo">
              <a-input v-model="model.terminalNo" placeholder="请输入终端号"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="TOKEN令牌" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="token">
              <a-input v-model="model.token" placeholder="请输入TOKEN令牌"  ></a-input>
            </a-form-model-item>
          </a-col>
          <a-col :span="24">
            <a-form-model-item label="状态" :labelCol="labelCol" :wrapperCol="wrapperCol" prop="status">
              <a-select v-model="model.status" style="width: 100%">
                <a-select-option value="0">关闭</a-select-option>
                <a-select-option value="1">启用</a-select-option>
              </a-select>
            </a-form-model-item>
          </a-col>
        </a-row>
      </a-form-model>
    </j-form-container>
  </a-spin>
</template>

<script>

  import { httpAction, getAction } from '@/api/manage'
  import { validateDuplicateValue } from '@/utils/util'

  export default {
    name: 'payInterfaceConfigForm',
    components: {
    },
    props: {
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        model:{
         },
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
          status: [
              { required: true, message: '请选择是否启用!'},
           ],
           payTypeId: [
              { required: true, message: '请输入关联支付方式!'},
           ],
           merchantNo: [
              { required: true, message: '请输入商户号!'},
           ],
           terminalNo: [
              { required: true, message: '请输入终端号!'},
           ],
           token: [
              { required: true, message: '请输入TOKEN令牌!'},
           ],
        },
        url: {
          add: "/business/busPayInterfaceConfig/add",
          edit: "/business/busPayInterfaceConfig/edit",
          queryById: "/business/busPayInterfaceConfig/queryById",
          query_payType: "/business/busRoomPayType/queryList",
        },
        payTypeList:[]
      }
    },
    computed: {
      formDisabled(){
        return this.disabled
      },
    },
    created () {
       //备份model原始值
      this.modelDefault = JSON.parse(JSON.stringify(this.model));
      getAction(this.url.query_payType,{}).then((res)=>{
        if(res.success){
          this.payTypeList = res.result
        }else{

        }
      })
    },
    methods: {
      add () {
        this.edit(this.modelDefault);
      },
      edit (record) {
        this.model = Object.assign({}, record);
        this.visible = true;
        if(!this.model.id){
          this.model.status = "1";
        }else{
          this.model.status = record.status.toString();
        }
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.$refs.form.validate(valid => {
          if (valid) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
              var info = JSON.parse(localStorage.getItem("storeInfo"));
              this.model.hotelId = info.id;
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            httpAction(httpurl,this.model,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }

        })
      },
    }
  }
</script>
